

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.8.16. TokenTable &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.8.17. TokenTrigram" href="token_trigram.html" />
    <link rel="prev" title="7.8.15. TokenRegexp" href="token_regexp.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/tokenizers/token_table.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="token_trigram.html" title="7.8.17. TokenTrigram"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="token_regexp.html" title="7.8.15. TokenRegexp"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../tokenizers.html" accesskey="U"><span class="section-number">7.8. </span>Tokenizers</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.8.16. </span><code class="docutils literal notranslate"><span class="pre">TokenTable</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="tokentable">
<h1><span class="section-number">7.8.16. </span><code class="docutils literal notranslate"><span class="pre">TokenTable</span></code><a class="headerlink" href="#tokentable" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.8.16.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenTable</span></code> is a tokenizer which treats only known keywords as a token.
The known keywords must be registered as a key in the table for <code class="docutils literal notranslate"><span class="pre">TokenTable</span></code>.</p>
<p>For example, query contains a known keyword and a unknown keyword, only a known keyword is
used in search query (unknown keyword will be ignored). In other words, you can search contents with only known keywords.
Because of this characteristic, you need to maintain keyword table for a new keyword continuously.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.8.16.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenTable</span></code> has a required parameter.</p>
<p>Specify the table:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>TokenTable(&quot;table&quot;, TABLE)
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">TABLE</span></code> must be created with <code class="docutils literal notranslate"><span class="pre">--default_tokenizer</span> <span class="pre">'TokenTable(&quot;table&quot;,</span> <span class="pre">TABLE)</span></code>.</p>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.8.16.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here is an example of <code class="docutils literal notranslate"><span class="pre">TokenTable</span></code>.
For example, let’s search <code class="docutils literal notranslate"><span class="pre">Raspberry</span> <span class="pre">Pie</span></code> from <code class="docutils literal notranslate"><span class="pre">Pies</span></code> table.
The table which is used for keyword is <code class="docutils literal notranslate"><span class="pre">Keywords</span></code>.</p>
<p>Here is the sample schema and data:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Pies TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Pies name COLUMN_SCALAR Text
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Keywords TABLE_PAT_KEY ShortText --default_tokenizer &#39;TokenTable(&quot;table&quot;, &quot;Keywords&quot;)&#39;
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Keywords index COLUMN_INDEX Pies name
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table Keywords
[
{&quot;_key&quot;: &quot;Apple&quot;}
{&quot;_key&quot;: &quot;Orange&quot;}
{&quot;_key&quot;: &quot;Raspberry&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 3]
load --table Pies
[
{&quot;name&quot;: &quot;Apple Pie&quot;},
{&quot;name&quot;: &quot;Orange Pie&quot;}
{&quot;name&quot;: &quot;Raspberry Pie&quot;}
{&quot;name&quot;: &quot;Stargazy Pie&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 4]
</pre></div>
</div>
<p>Then search <code class="docutils literal notranslate"><span class="pre">Raspberry</span> <span class="pre">Pie</span></code> with <code class="docutils literal notranslate"><span class="pre">--query</span> <span class="pre">Raspberry</span></code>.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Pies --match_columns name --query &#39;Raspberry&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;name&quot;,
#           &quot;Text&quot;
#         ]
#       ],
#       [
#         3,
#         &quot;Raspberry Pie&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>As you expected, the above query matches the <code class="docutils literal notranslate"><span class="pre">Raspberry</span> <span class="pre">Pie</span></code> record.</p>
<p>Next, search <code class="docutils literal notranslate"><span class="pre">Stargazy</span> <span class="pre">Pie</span></code> with <code class="docutils literal notranslate"><span class="pre">--query</span> <span class="pre">Stargazy</span></code>.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Pies --match_columns name --query &#39;Stargazy&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         0
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;name&quot;,
#           &quot;Text&quot;
#         ]
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>In above example, as the keyword <code class="docutils literal notranslate"><span class="pre">Stargazy</span></code> is not registered in <code class="docutils literal notranslate"><span class="pre">Keywords</span></code> table yet, it doesn’t match anything.</p>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.8.16.4. </span>See also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../commands/tokenize.html"><span class="doc">tokenize</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.8.16. <code class="docutils literal notranslate"><span class="pre">TokenTable</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.8.16.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.8.16.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.8.16.3. Usage</a></li>
<li><a class="reference internal" href="#see-also">7.8.16.4. See also</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="token_regexp.html"
                        title="previous chapter"><span class="section-number">7.8.15. </span><code class="docutils literal notranslate"><span class="pre">TokenRegexp</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="token_trigram.html"
                        title="next chapter"><span class="section-number">7.8.17. </span><code class="docutils literal notranslate"><span class="pre">TokenTrigram</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="token_trigram.html" title="7.8.17. TokenTrigram"
             >next</a> |</li>
        <li class="right" >
          <a href="token_regexp.html" title="7.8.15. TokenRegexp"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../tokenizers.html" ><span class="section-number">7.8. </span>Tokenizers</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.8.16. </span><code class="docutils literal notranslate"><span class="pre">TokenTable</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>